package chat.client;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.UnknownHostException;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

public class ClientFrame extends JFrame{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public class ClientSwing extends AbstractClient{
		
		public ClientSwing(String server, int port, String alias)
				throws UnknownHostException, IOException {
			super(server, port, alias);
		}
		@Override
		public void displayMessage(String message) {
			ClientFrame.this.afficheur.append(message+'\n');
		}

		@Override
		public void displayError(String message) {
			// TODO Auto-generated method stub
			ClientFrame.this.afficheur.append(message+'\n');
		}
		
	}
	
	private JTextArea afficheur;
	private JTextField input;
	private JButton submitBut;
	private ClientSwing client;

	//CONSTRUCTEUR DE L'INTERFACE
	public ClientFrame(String server, int port, String alias){
		try {
			this.client = new ClientSwing(server, port, alias);
			this.client.start();
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.setTitle("Chat");
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		
		this.afficheur = new JTextArea();
		this.afficheur.setColumns(50);
		this.afficheur.setRows(10);
		this.afficheur.setEditable(false);
		this.add(this.afficheur);
		
		JPanel transmissionBar = new JPanel();
		this.input = new JTextField(50);
		this.submitBut = new JButton("Send");
		this.submitBut.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				client.sendToServer(ClientFrame.this.input.getText());
				ClientFrame.this.input.setText(null);
			}
		});
		transmissionBar.add(this.input);
		transmissionBar.add(this.submitBut);
		this.add(transmissionBar);
		this.pack();
		
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				String alias = JOptionPane.showInputDialog("Entrez votre pseudo : ");
				ClientFrame frame = new ClientFrame("localhost", 3333, alias);
				//Envoi l'alias du client au server
				//frame.client.sendToServer(alias+"#ALIAS");
				frame.setVisible(true);
			}
		});
	}

}
